/** apikey.cpp
 * APIL[̊ǗFC++\[X
 *
 * @copyright	(c)studio pahoo
 * @author		ppςӂ
 * @	MinGW C++ + cURL + OpenSSL + Boost C++ Libraries
 *					Leaflet + OSM (+ GoogleMape)
 * @QlURL		http://www.pahoo.org/e-soul/webtech/cpp01-15-01.shtm
 */
#include <iostream>
#include <fstream>
#include "apikey.h"
#include "mystrings.h"
#include "pahooGeocode.hpp"
#include "resource.h"

using namespace std;

// Oϐ ================================================================
//݂̃C^[tFCX
extern HINSTANCE hInst;

// pahooGeoCodeIuWFNg
extern pahooGeocode *pGC;

// TuEvO =====================================================
/**
 * CxgnhFGoogle APIL[̓_CAO
 * @param	HWND hDlg			EBhEEnh
 * @paramm	UINT uMsg			bZ[Wʎq
 * @param	WPARAM wParam		bZ[W̍ŏ̃p[^
 * @paramL	PARAM lParam		bZ[W2Ԗڂ̃p[^
 * @return	INT_PTR CALLBACK	TRUEFbZ[W^FALSEF
 */
INT_PTR CALLBACK processGoogleAPIkey(HWND hDlg, UINT uMsg,
						WPARAM wParam, LPARAM lParam) {
	int res;

	switch (uMsg) {
	//_CAO
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_APIKEY, "Google APIL[́Eۑ܂D");
		setStrEditBox(hDlg, IDC_EDIT_APIKEY, pGC->GoogleAPIkey);
		break;

	//{^
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		//ۑ
		case IDC_BUTTON_APIKEY_SAVE:
			pGC->writeGoogleApiKey(getStrEditBox(hDlg, IDC_EDIT_APIKEY));
			EndDialog(hDlg, 0);
			break;
		//폜
		case IDC_BUTTON_APIKEY_DELETE:
			res = MessageBox(NULL, TEXT("{ɍ폜܂H"),
				TEXT("Google APIL[폜"), MB_OKCANCEL | MB_ICONQUESTION);
			switch (res) {
			case IDOK:
				pGC->writeGoogleApiKey("");
				break;
			default:
				break;
			}
			EndDialog(hDlg, 0);
			break;
		case IDC_BUTTON_APIKEY_CANCEL:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
	//vOI
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * Google APIL[̓_CAO쐬
 * @param  HINSTANCE hInst	݂̃C^[tF[X
 * @param  HWND hDlg		eEBhEEnh
 * @return Ȃ
 */
void createGoogleAPIkey(HWND hDlg) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_GOOGLE_APIKEY), hDlg,
			(DLGPROC)processGoogleAPIkey);
}

/**
 * CxgnhFYahoo!AvP[VID̓_CAO
 * @param	HWND hDlg			EBhEEnh
 * @paramm	UINT uMsg			bZ[Wʎq
 * @param	WPARAM wParam		bZ[W̍ŏ̃p[^
 * @paramL	PARAM lParam		bZ[W2Ԗڂ̃p[^
 * @return	INT_PTR CALLBACK	TRUEFbZ[W^FALSEF
 */
INT_PTR CALLBACK processYahooAPIkey(HWND hDlg, UINT uMsg,
					WPARAM wParam, LPARAM lParam) {
	ofstream ofs;
	int res;

	switch (uMsg) {
	//_CAO
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_APIKEY, "Yahoo!AvP[VID ́Eۑ܂D");
		setStrEditBox(hDlg, IDC_EDIT_APIKEY, pGC->YahooAPIkey);
		break;

	//{^
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		//ۑ
		case IDC_BUTTON_APIKEY_SAVE:
			pGC->writeYahooApiKey(getStrEditBox(hDlg, IDC_EDIT_APIKEY));
			EndDialog(hDlg, 0);
			EndDialog(hDlg, 0);
			break;
		//폜
		case IDC_BUTTON_APIKEY_DELETE:
			res = MessageBox(NULL, TEXT("{ɍ폜܂H"),
				TEXT("Yahoo!AvP[VID폜"), MB_OKCANCEL | MB_ICONQUESTION);
			switch (res) {
			case IDOK:
				pGC->writeYahooApiKey("");
				break;
			default:
				break;
			}
			EndDialog(hDlg, 0);
			break;
		//LZ
		case IDC_BUTTON_APIKEY_CANCEL:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
	//vOI
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * Yahoo!AvP[VID̓_CAO쐬
 * @param  HWND hDlg		 eEBhEEnh
 * @return Ȃ
 */
void createYahooAPIkey(HWND hDlg) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_YAHOO_APIKEY), hDlg,
			(DLGPROC)processYahooAPIkey);
}

/*
 ** o[WAbv =====================================================
 *
 * @version  1.0  2020/09/30
 */
